#  readConfig.pm
#    - locate config file 
#
#  Copyright (C) 2004 Doolin Technologies
#
#  This module is free software; you can redistribute it and/or modify it
#  under the same terms as Perl itself.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
#  $Id: ReadConfig.pm,v 1.4 2004/10/29 16:17:21 jamesc Exp $
#

package SmsEngine::ReadConfig;

use strict;
use bytes;

use vars qw($VERSION @EXPORT_OK @ISA @EXPORT);
use FindBin qw($Bin $Script $RealBin $RealScript);
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw();
@EXPORT_OK = qw(findConfig);
$VERSION = sprintf('%d.%02d', (q$Revision: 1.4 $ =~ /\d+/g));

my $debug = 1;

sub findConfig {

    # Take in the argument
    my $path = shift;
    my $mailto = shift;

    # 1st check have we specified full file and path
    if (-f $path){
	return $path;
    }

    my $searching;
    my $dir = $Bin;

    # Loop while the directory we are running the 
    # script is not null
    do {

	$searching = $dir."/etc/".$path;
	print "findConfig $searching\n" if ($debug);
        # If the file exists
        if (-f $searching){

            # return the full path to the config file
            return $searching;
        }

        # Reverse the directory path
        $dir = reverse($dir);

        # Substitute everything up to and including the first 
        # forward slash with nothing
        $dir =~ s/^.*?\///;

        # Reverse the string so its bacj to its original
        $dir = reverse($dir);

    }while($dir ne "");

    $searching = $dir."/etc/".$path;
    print "findConfig $searching\n" if ($debug);

    # If the file exists
    if(-f $searching){

        # send back the full path to the file
        return $searching;

    } else {

	if ($mailto && ($mailto |= "")) {
	    open(MAIL, "|mail '$mailto' -s \"ERROR finding $path\"");
	    print MAIL ("Error finding $path.\n\n");
	    close(MAIL);
	}

        # do not die die "Error finding $path";
        # Config file wasn't found
        return undef;

    }

}

1;
