#!/usr/bin/perl -Tw

# make TEST_FILES=t/smsengine-o2mapchars.t test

use strict;
use bytes;

use lib qw(t/lib);
use Test::More tests => 
    2 +          # use ok, create ok
    3;           # map chars

BEGIN { use_ok('SmsEngine::SmsEngine') }

my $ti = 1;
my $tn = "";
sub registerTest
{
    $ti++;
    $tn = shift;
}

my $goodresult;

#start o2proprietary testbed
my $sendsms = SmsEngine->new( file => "example.conf", 
			      debug => 0,
			      verbose => 0 );
			      #iface => "o2proprietary_iface", 
			      #account => "topupclub_o2_account" );

::ok(defined($sendsms),"smsengine o2 prop object create okay");

registerTest("map chars for send sms");

my $teststr = $_ = "test string";
$sendsms->{ObjectSms}->encode_chars_for_tx();
::is($_,$teststr,$tn."-".$teststr);

$teststr = $_ = "\$&<>¡£";
my $resultstr = "&#036;&amp;&lt;&gt;&#161;&#163;";
$sendsms->{ObjectSms}->encode_chars_for_tx();
::is($_,$resultstr,$tn."-".$teststr);

SKIP: {
    skip "not to spec, not done, no time to do it", 1;

    $teststr = $_ = "ctrl chars \x00\x01\x02\x03\x04\x05\x06\x077 ".
        #"\x088 \x099 \x0AA \x0BB \x0CC \x0DD \x0EE \x0FF ".
	"\x088 \x099 \x0EE \x0FF ".
	"\x1010 \x1111 \x1212 \x1313 \x1414 \x1515 \x1616 \x1717 ".
	"\x1818 \x1919 \x1A1A \x1B1B \x1C1C \x1D1D \x1E1E \x1F1F ".
	"moo";
    $resultstr = "ctrl chars 7 \x088  9 E F 10 11 12 13 14 15 16 17 ".
	"18 19 1A \x1B1B 1C 1D 1E 1F ".
	"moo"; # 8del 9?inserts? A-D cr 1B?weird ish consumes next char (1 of 1B) fwd-del?
    $sendsms->{ObjectSms}->encode_chars_for_tx();
    ::is($_,$resultstr,$tn."-".$resultstr);

    my $debug = 1;
    my $texthex = join("", map { sprintf "%02x", $_ } unpack("C*",$teststr));
    print STDERR "texthex: " . $texthex . "\n" if ($debug);
    $texthex = join("", map { sprintf "%02x", $_ } unpack("C*",$resultstr));
    print STDERR "texthex: " . $texthex . "\n" if ($debug);
    $texthex = join("", map { sprintf "%02x", $_ } unpack("C*",$_));
    print STDERR "texthex: " . $texthex . "\n" if ($debug);
}


# they're stull there ... they're just hiding! :(
