#!/usr/bin/perl -w

use HTTP::Daemon;
use HTTP::Status;
use Carp;
use bytes;
use strict;

my ($debug, $port);
my $configfile ="smsengine.topupclub.xiam.conf";

# this message really from xiam
my $test = <<EOT
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xiamSMS SYSTEM "xiamSMSMessage.dtd">
<xiamSMS>
<deliverRequest id="1907500">
<receivedOnGroup value="SMPP-O2"/>
<to npi="Unknown">53125</to>
<udh value=""/>
<carrierType value="SMPP"/>
<sendOnPath value="103"/>
<from>353861953134</from>
<content type="text">TUCTEST</content>
<xirMessageID value="1907500"/>
</deliverRequest>
</xiamSMS>
EOT
;

#test/o2xiamsend.pl -d -rxml "<xiamSMS><deliverRequest id=\"miaow\"><from>from</from><to>+353119898989</to><xirMessageID value=\"1234567\"/></deliverRequest></xiamSMS>" -u http://localhost:8101/sms/xiam/in
#my $test = "<xiamSMS><deliverRequest id=\"miaow\"><from>from</from><to>+353119898989</to><xirMessageID value=\"1234567\"/></deliverRequest></xiamSMS>";
#my $test = "<xiamSMS><deliverRequest id=\"miaow\"></deliverRequest></xiamSMS>";
#my $test = "<xiamSMS><deliverRequest id=\"miaow\"><xirMessageID value=\"1234567\"/></deliverRequest></xiamSMS>";
#my $test = "<xiamSMS><deliverRequest id=\"miaow\"><xirMessageID /></deliverRequest></xiamSMS>";
#my $response = parse_xiam_xml($test);
#exit;

my $usage = <<END;
usage: $0 [-d] [-p port] [-c configfile]

e.g. $0
e.g. $0 -d -p 8101

END

while (defined($ARGV[0])) {

    if ($ARGV[0] =~ "^-d") {
	$debug = shift(@ARGV);
    } elsif ($ARGV[0] =~ "^-p") {
	shift(@ARGV);
	$port = shift(@ARGV);
    } elsif ($ARGV[0] =~ "^-c") {
	shift(@ARGV);
	$configfile = shift(@ARGV);
	croak "-c configfile param not done yet.";
    } else {
	croak "unknown param " . shift(@ARGV) . "\n".$usage;
    }

}

$port = 8101 if (!defined($port));

my $d = HTTP::Daemon
    #-> new (io_socket_timeout => 10, socket_read_timeout => 10,
	#    LocalPort => $port, Reuse => 1)
    #-> new (LocalPort => $port, ReuseAddr => 1)
    #-> new (LocalPort => $port, ReusePort => 1)
    #-> new (LocalPort => $port, Reuse => 1)
    -> new (LocalPort => $port);
#    || croak "fail to create HTTP::Daemon: $!";

# we have to do this stuff as we do not seem to be able to set Reuse/ReusePort
if (!defined $d) {
    warn "fail to create HTTP::Daemon: $!";
    my $retrycount = 0;
    while(!defined($d) && $retrycount < 9) {
	sleep(7); # 63 sec, assuming TIME_WAIT is less than that.
	warn "Retry $retrycount create HTTP::Daemon.";
	$d = HTTP::Daemon
	    -> new (LocalPort => $port);
	if (!defined $d) {
	    warn "fail to create HTTP::Daemon: $!";
	} else {
	    warn "whew! Created HTTP::Daemon.";
	    #last; #next; #continue; #redo;
	}
	$retrycount++;
    }
}

croak "fail to create HTTP::Daemon: $!"
    if (!defined $d || !$d);

print "this is me at: <URL:", $d->url, ">\n";
logsmsin ("Doolin SmsEngine xiam sms rx daemon started at: <URL:". $d->url. ">\n");

while (my $c = $d->accept) {

    my $t = time();
    logsmsin ("ACCEPT:" . $t . "\n");
    while (my $r = $c->get_request) {
	my $t = time();
	logsmsin ("REQUEST:" . $t . "\n");
	use Data::Dumper; print Dumper($r);
	use Data::Dumper; logsmsin(Dumper($r));

	if ($r->method eq 'GET' and $r->url->path eq "/xyzzy") {
	    logsmsin ("SEND FILE FUNNYPATH");
	    $c->send_file_response("o2xiamreceive.pl");
	    # $c->send_response("TODO: simulate o2 xiam sms out server");	    
	} elsif ($r->method eq 'POST' and $r->url->path eq "/smsxml" 
		 or $r->url->path eq "/sms/xiam/in") {
	    my $response = parse_xiam_xml($r->content);
            my $t = time();
	    logsmsin ("SEND RESPONSE $t $response");

          # http://www.faqs.org/rfcs/rfc2616.html
	  #1101993027:TopUpClub:xiam sms receiving via ssh trick but response not received back. working out protocol details by trial & error & hand

	    #$c->send_status_line( 200, $response, "" ); # blank success resp to perl
	    #$c->send_status_line( 200, $response, "HTTP/1.1" ); # blank success resp to perl

	    #$c->send_status_line( $code, $mess, $proto );
	    #$c->send_status_line( 200, $response); # blank success resp to perl  (sends HTTP/1.1 200 in front)
	    #$c->send_status_line( "", $response, "" ); #blank(sends HTTP/1.1 200 in front)
	    #$c->send_status_line( 200, $response, "" ); #blank
	    #$c->send_status_line( "200", $response, "" ); #blank

	    #$c->send_basic_header;

	    $c->send( $response);
	    $c->close;#$c->force_last_request;

	    #$c->send_response($response); # success resp HTTP/1.1 <content> to perl (sends HTTP/1.1 in front)	    


	#} elsif ($r->method eq 'POST') {
	#    $c->send_response($errorresponse);	    
	} else {
	    logsmsin ("SEND ERROR FORBIDDEN");
	    $c->send_error(RC_FORBIDDEN);
	}
    }
    # do not close immediately?
    #$t = time();
    #logsmsin ("SLEEP:" . $t . "\n");
    #sleep(2);
    #my $r = $c->get_request;
    #use Data::Dumper; print Dumper($r);
    #use Data::Dumper; logsmsin(Dumper($r));
    #$c->send_response("\n\n\n");	    
    #$t = time();
    #logsmsin ("SLEEP:" . $t . "\n");
    #sleep(2);

    $t = time();
    logsmsin ("CLOSE:" . $t . "\n");
    $c->close;
    undef($c);
}



sub logsmsin {
    my $msg = shift;
    open(LOG, ">>xiamin.log") || croak "can't open log: $!";
    print STDERR $msg if (defined($debug));
    print LOG $msg."\n";
    close LOG;
}

sub psmserr {
    my $msg = "Error: " . shift;
    print STDERR $msg . "\n";
    logsmsin($msg);
}

sub make_xiam_xml {
    my $msg = shift;
    my $xiamSMSmsg = <<EOT
  <?xml version="1.0" encoding="UTF-8"?>
  <!DOCTYPE xiamSMS SYSTEM "xiamSMSMessage.dtd">
  <xiamSMS>
    $msg
  </xiamSMS>
EOT
;
    return $xiamSMSmsg;
}

sub make_xiam_xml_err {
    my $msg = shift;
    my $resp = <<EOT
    <error>
      <result status="ERROR">$msg</result>
    </error>
EOT
;
    return make_xiam_xml($resp);    
}

#use XML::Parser;
use XML::SimpleObject;

sub childval {
    my $ref = shift;
    return $ref->value if (defined($ref));
}

sub childattrval {
    my $type = shift;
    my $ref = shift; # $ref can be undef so must be after last definately defined thing
    #print Dumper($ref);
    return $ref->attribute($type) if (defined($ref) && $ref->attributes);
}

sub walkchildren {
    my $ref = shift;
    my $path = shift || "";
    my $i = shift || 0;

    #use Data::Dumper; print STDERR "Dump:".Dumper($ref) if ($i == 0);
    #print "i $i\n";
    #use Data::Dumper; print STDERR "Dump:".Dumper($ref);
    if (defined($ref)) {
	# sttributes
	if ($ref->attributes) {
	    my %attrs = $ref->attributes;
	    while ( my ($key, $value) = each %attrs) {
		print "path: $path attr: $key:".$value."\n";
	    }
	}
	# children
	foreach my $child ($ref->children) {
	    print "path: $path/child: ", $child->name, ": ", $child->value, "\n" if ($child->value);
	    walkchildren($child,$path."/".$child->name,++$i);
	}
    }
}

#my ($root, $type, $object, $msgid, $ref) = parse_xiam_xml($input);
sub parse_xiam_xml {
    my ($request) = @_;
    chomp($request);
    my $ref;

    # ngeh
    $request =~ s/<\?xml\s[^>]+>//;
    $request =~ s/<\!DOCTYPE\s[^>]+>//;
    #$request =~ "<xml>".$request."</xml>";

    my $parser = new XML::Parser(ErrorContext => 2, Style => "Tree");

    # ensure server doesn't die
    # silly silly XML::Parser calls die

    eval {
	$ref = new XML::SimpleObject($parser->parse($request));
    };

    # TODO check for error
    # handle exception errors
    if ($@) {
        psmserr("parse_xml Error parsing XML request ".
		"( $request ) ( $@ ) invalid format.");
        return;
    }

    walkchildren($ref);

    #print Dumper($request);

    # validation
    if (!defined($ref->child("xiamSMS"))) {
        psmserr("parse_xml Error in XML request ".
		"- invalid or no root element. ".
		" Valid Root elements are: xiamSMS");
        #logevent($MSG_DBG, XMLout($ref, KeepRoot => 1));
        return;
    }

    #use Data::Dumper; print STDERR "Dump:".Dumper($ref);

    # SMS
    if (defined($ref->child("xiamSMS")->child("deliverRequest"))) {

	my $dr = $ref->child("xiamSMS")->child("deliverRequest");
	my ($id, $to, $from, $xmid) = ("", "", "", "");

	#print Dumper($dr->attributes);;
	$id = $dr->attribute("id");
	#$from = $dr->child("from")->value if (defined($dr->child("from")));
	$from = childval($dr->child("from"));
	$to = childval($dr->child("to"));
	$xmid = childattrval("value", $dr->child("xirMessageID"));
	print "XMID: $xmid\n";

	my $rog = childattrval("value", $dr->child("receivedOnGroup"));
	my $udh = childattrval("value", $dr->child("udh"));
	my $ct = childattrval("value", $dr->child("carrierType"));
	my $sop = childattrval("value", $dr->child("sendOnPath"));

# real example
#<?xml version="1.0" encoding="UTF-8"?>
#<!DOCTYPE xiamSMS SYSTEM "xiamSMSMessage.dtd">
#<xiamSMS>
#<deliverRequest id="1907500">
#<receivedOnGroup value="SMPP-O2"/>
#<to npi="Unknown">53125</to>
#<udh value=""/>
#<carrierType value="SMPP"/>
#<sendOnPath value="103"/>
#<from>353861953134</from>
#<content type="text">TUCTEST</content>
#<xirMessageID value="1907500"/>
#</deliverRequest>
#</xiamSMS>

	# try adding + if no + already?
	#$from = "+".$from if ($from !~ "^[+]");
	#$to = "+".$to if ($to !~ "^[+]");

	# TODO parse out params
	my $resp = "<deliverResponse id=\"$id\">" .
            # $from in result, not $to! (says Andrew xiam) looks like it's the $to in doc in example
	    "<result status=\"OK\">$from</result>" . 
	    ###"<result status=\"OK\" value=\"OK\">$from</result>" .
	    #"<from>$from</from>" .
	    #"<to>$to</to>" .
	    #"<xirMessageID value=\"$xmid\"/>" .
	    #"<receivedOnGroup value=\"$rog\"/>".
            ###"<to npi=\"Unknown\">53125</to>".
	    #"<udh value=\"$udh\"/>".
	    #"<carrierType value=\"$ct\"/>".
	    #"<sendOnPath value=\"$sop\"/>".
	    #"<content type=\"text\">TUCTEST</content>".
	    "</deliverResponse>";

	if (0) {
	    my $immresptext = "james test immediate response";
	    $resp .= "\n<submitRequest id=\"immresp$id>\>".
		"<from>$to</from>".
		"<to>$from</to>".
		"<content type=\"text\">$immresptext</content>" .
		"<requestDeliveryReport value=\"yes\" />" .
		"</submitRequest>";
	}

	my $xiamresp = make_xiam_xml($resp);

	psmserr("parse_xml send SMS response $xiamresp");

	return $xiamresp;

    } elsif (defined($ref->child("xiamSMS")->child("reportRequest"))) {

	my $rr = $ref->child("xiamSMS")->child("reportRequest");
	my ($id, $to, $from, $xmid, $status, $statustext) = ("", "", "", "", "", "");

	# not sure if report will have id
	$id = $rr->attribute("id");

	$from = childval($rr->child("from"));
	$to = childval($rr->child("to"));
	$xmid = childattrval("value", $rr->child("xirMessageID"));
	print "XMID: $xmid\n";

	$status = childval($rr->child("smscStatus"));
	$statustext = childval($rr->child("smscStatusText"));
	
	my $resp = "<reportResponse id=\"$id\">" .
	    "<result status=\"OK\">$to</result>" .
	    "</reportResponse>";

	my $xiamresp = make_xiam_xml($resp);

	psmserr("parse_xml send SMS report response $xiamresp");

	return $xiamresp;

	# TODO
    } elsif (defined($ref->child("xiamSMS")->child("submitResponse"))) {
	# TODO
	use Data::Dumper;
	psmserr("TODO: submitResponse ".
			"Request:".Dumper($request) .
			"Dump:".Dumper($ref));
	return 0;

    } elsif (defined($ref->child("xiamSMS")->child("submitRequest"))) {
	# TODO only for testing/simulate
	use Data::Dumper;
	psmserr("TODO: submitRequest ".
			"Request:".Dumper($request) .
			"Dump:".Dumper($ref));
	return 0;

    } else {
	use Data::Dumper;
	psmserr("parse_xml Error in XML unknown request".
			"Request:".Dumper($request) .
			"Dump:".Dumper($ref));
	return 0;
    }

    return 0; # impossible
}



=head1 NAME

o2xiamsend.pl - test script send sms o2 xiam sms/xml iface

=head1 SYNOPSIS

$usage

=head1 NOTES

  Forward port 8101 on bakunin to betty 8101
  incoming sms from o2 xiam sms/xml
  [jamesc@bakunin smsengine]$ ssh -L 8101:betty:8101 jamesc@betty -g
  [jamesc@bakunin jamesc]$ telnet bakunin  8101
  [jamesc@anywhere smsengine]$ test/o2xiamsend.pl -rdel ngeh -u http://bakunin:8101/sms/xiam/in
   test/o2xiamsend.pl -rxml  -u http://bakunin:8101/sms/xiam/in

 # xml parse lib doesn't like <?xml version="1.0" encoding="UTF-8"?>
 # xml parse lib doesn't like whitespace within xml

 test/o2xiamsend.pl -u http://bakunin:8101/sms/xiam/in -rxml "
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE xiamSMS SYSTEM "xiamSMSMessage.dtd">
  <xiamSMS>
      <deliverRequest id="xir-ngeh">
      <from>o2xiamsend.pl</from>
      <to></to>
      <content type="text"></content>
      <smscTimestamp type="Absolute">
        <year>2003</year>
        <month>03</month>
      </smscTimestamp>
      <carrierType value="SMPP" />
      <receivedOnPath value="42" />
      <xirMessageID value="ngeh" />
  </deliverRequest>
  </xiamSMS>"
 
 test/o2xiamsend.pl -u http://bakunin:8101/sms/xiam/in -rxml "
<!DOCTYPE xiamSMS SYSTEM \"xiamSMSMessage.dtd\">
<xiamSMS>
<deliverRequest id=\"xir-ngeh\">
<from>o2xiamsend.pl</from>
<to></to>
<content type=\"text\"></content>
<smscTimestamp type=\"Absolute\">
<year>2003</year>
<month>03</month>
</smscTimestamp>
<carrierType value=\"SMPP\" />
<receivedOnPath value=\"42\" />
<xirMessageID value=\"ngeh\" />
</deliverRequest>
</xiamSMS>"

test/o2xiamsend.pl -d -rxml "<xiamSMS><deliverRequest id=\"miaow\"><from>from</from><to>+353119898989</to><xirMessageID value=\"1234567\"/></deliverRequest></xiamSMS>" -u http://localhost:8101/sms/xiam/in

test/o2xiamsend.pl -u http://bakunin:8101/sms/xiam/in -rxml "
<xiamSMS><reportRequest id=\"xir-ngeh\">
<from>o2xiamsend.pl</from>
<to></to>
<smscReference value=\"3\" />
<smscTimestamp type=\"Absolute\">
<year>2003</year>
<month>03</month>
</smscTimestamp>
<carrierType value=\"SMPP\" />
<receivedOnPath value=\"42\" />
<xirMessageID value=\"ngeh\" /><smscStatusText value=\"ACCEPTED\" />
</reportRequest></xiamSMS>"

=cut
