#!/usr/bin/perl -w
#
#  o2xmlrpcin.pl
#    - xml-rpc https interface
#    - simulate sms sent from o2
#
#  Copyright (C) 2004 Doolin Technologies
#
#  $Id: o2xmlrpcin.pl,v 1.6 2004/09/14 15:08:45 jamesc Exp $
#

use bytes;

use XMLRPC::Lite on_fault => sub {my($soap, $res) = @_; die ref $res ? $res->faultdetail : $soap->transport->status, "\n"};
use XMLRPC::Lite +trace => 'debug';
#use XMLRPC::Lite;

### TODO: pass stuff in argv, make functions

my $usage = <<END;
usage: $0 [-s server] [-p port] [-c xmlrpcfunctioncall] [from] [msg] [shortcode] [network]

e.g. $0 -s bakunin -p 8987 -c XMLRPCHandler.getContent 353867456789 "TUC REGISTER 1212123"
e.g. $0 353867456789 "TUC REGISTER 1212123"
e.g. $0 353867456789 "TUC REGISTER 1212123" 353863832032 O2I
e.g. $0 353867456789 "TUC REGISTER 1212123" 353863833342 O2I

END

my ($debug, $verbose, $server, $port, $call, $from, $msg);

while ($ARGV[0] =~ "^-") {


    if ($ARGV[0] =~ "-d") {
	$debug = shift(@ARGV);
    } elsif ($ARGV[0] =~ "-v") {
	$verbose = shift(@ARGV);
    } elsif ($ARGV[0] =~ "-s") {
	shift(@ARGV);
	$server = shift(@ARGV);
    } elsif ($ARGV[0] =~ "-p") {
	shift(@ARGV);
	$port = shift(@ARGV);
    } elsif ($ARGV[0] =~ "-c") {
	shift(@ARGV);
	$call = shift(@ARGV);
    } else {
	die "unknown param " . shift(@ARGV);
    }

}

if ($#ARGV < 1 ) {   #read perldoc perlvar for ARGV
    die "$usage";
}

$from = shift(@ARGV);
$msg = shift(@ARGV);
$shortcode = shift(@ARGV);
$network = shift(@ARGV);

$server = "localhost" if (!$server);
$port = 8987 if (!$port);
$call = 'XMLRPCHandler.getContent' if (!$call);

# TODO $call and params as perl tjhingy that can be eval'd

$from = "447764339227" if (!$from);
$msg =  "TUC REGISTER 434565762345" if (!$msg);
$shortcode = "8320100" if (!$shortcode);
$network = "O2I" if (!$network);

$res = getContent($server,$port,$call,$from,$msg);
printRes($res) if ($verbose);

sub getContent { 
    my $server = shift;
    my $port = shift;
    my $call = shift;
    my $from = shift;
    my $msg = shift;

    # SMS from o2!!!
    print "call $server:$port $call $from $msg" if ($verbose);
    $res = XMLRPC::Lite
    -> proxy("http://$server:$port/")
    -> call("$call", 
	    { SHORTCODE => qq($shortcode),
	      NETWORK => qq($network),
	      MSISDN => qq($from),
	      msg => qq($msg) })
    -> result;
    return $res;
}

sub printRes {
    my $res = shift;
    #print $res;
    print "RESULT $res RESULT\n" if ($verbose);
    # msg txt like yoke
    my $content = $res->{Content};
    print "content:".$content." ";
    my $type = $res->{Content}->{Type};
    print "type:".$type." ";
    my $message = $res->{Content}->{Message};
    print "message:".$message." ";
#my $text = $res->{Content}->{Message}->{text}; #"Bad index while coercing array into hash at xmlrpccall.pl line 80."
    my $text = $res->{Content}->{Message}[0]->{text};
    print "text:".$text." ";
}


exit(0);

print "call XMLRPCHandler.getContent";
$res = XMLRPC::Lite
#    -> proxy('http://localhost:8987')
    -> proxy('http://bakunin.dev.ie.alphyra.com:8987/')
    -> call('XMLRPCHandler.getContent', 
	    { SHORTCODE => 8320100, 
	      NETWORK => "O2",
	      MSISDN => 447764339227,
	      msg => "hello thar Rpctest nasty chars \n :( <  > <mork> " })
    -> result;
print $res;
print "RESULT $res RESULT\n";
# msg txt like yoke
my $content = $res->{Content};
print "content:".$content." ";
my $type = $res->{Content}->{Type};
print "type:".$type." ";
my $message = $res->{Content}->{Message};
print "message:".$message." ";
#my $text = $res->{Content}->{Message}->{text}; #"Bad index while coercing array into hash at xmlrpccall.pl line 80."
my $text = $res->{Content}->{Message}[0]->{text};
print "text:".$text." ";



# interesting - if you send funny chars they're packed inside <base64>
print "call XMLRPCHandler.getContent";
$res = XMLRPC::Lite
#    -> proxy('http://localhost:8987')
    -> proxy('http://bakunin.dev.ie.alphyra.com:8987/')
    -> call('XMLRPCHandler.getContent', 
	    { SHORTCODE => 8320100, 
	      NETWORK => "O2",
	      MSISDN => 447764339227,   #\" \@ \$
	      msg => "
20-40:  !\"#\$%&'()*+,-./0123456789:;<=>?
40-60: \@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_
60-7f: `abcdefghijklmnopqrstuvwxyz{|}~
wasabi! 
hello thar Rpctest nasty chars \n :( <  > <mork> " })
    -> result;

# terminal on other side doesn't particularily like these
# encoding => e.g.  ?
#a0-c0: 
#c0-e0: ÁāŁƁǁȁɁʁˁ́́΁ρЁсҁӁԁՁցׁ؁فځہ܁݁ށ
#e0-100: 

# 0x80 
# these are nasty 80-a0: 

if (0){
print $res;
print "RESULT $res RESULT\n";
# msg txt like yoke
my $content = $res->{Content};
print "content:".$content." ";
my $type = $res->{Content}->{Type};
print "type:".$type." ";
my $message = $res->{Content}->{Message};
print "message:".$message." ";
#my $text = $res->{Content}->{Message}->{text}; #"Bad index while coercing array into hash at xmlrpccall.pl line 80."
my $text = $res->{Content}->{Message}[0]->{text};
print "text:".$text." ";

# wasabi! 
}
