#!/bin/bash

if [[ "$1" == "" ]] ; then
  echo usage: $0 \<mobilenumber\>
  echo   e.g. $0 35386xxxxxxx
  exit
fi

mobilenumber=$1

status=`/sbin/service smsengine status`
running=`echo $status |grep running`
inprocstat=`ps -ef |grep o2xmlrpcin.daemon |egrep -v "(grep|xterm)"`
outprocstat=`ps -ef |grep o2xmlrpcout.daemon |egrep -v "(grep|xterm)"`

if [[ "$running" != "" ]] ; then

    echo testing smsengine running as service $status

else

    if [[ "$inprocstat" == "" ]] ; then
	echo smsengine sms in service is not running, will try to start test daemon in xterm
	xterm -e bin/o2xmlrpcin.daemon &
    fi

    if [[ "$outprocstat" == "" ]] ; then
	echo smsengine sms out service is not running, will try to start test daemon in xterm
	xterm -e bin/o2xmlrpcout.daemon &
    fi

fi

if [[ "$running" != "" ]] ; then
    inlog=/usr/local/smsengine/logs/smsengine.in.log
    outlog=/usr/local/smsengine/logs/smsengine.out.log

    #echo tail smsengine logs ?
    #read foo
    #if [[ $foo == "yes" ]] ; then
    touch $inlog
    touch $outlog
    opts="-title $inlog -geometry 92x45+20+0 -fg white -bg \"#9f0090\""
    xterm $opts -sb -sl 4000 -e tail -f $inlog &
    opts="-title $outlog -geometry 92x45+620+0 -fg white -bg \"#9f0090\""
    xterm $opts -sb -sl 4000 -e tail -f $outlog &
    #fi

else
    inlog=logs/smsengine.in.log
    outlog=logs/smsengine.out.log
fi

mkdir -p test/report

TRN=test/report/o2xmlrpcout-report
test/test-o2xmlrpcout.daemon.pl -m $mobilenumber 1>$TRN.txt 2>$TRN.warnings
#test/test-o2xmlrpcout.daemon.pl -m $mobilenumber -a 1>$TRN.txt 2>$TRN.warnings
#test/test-o2xmlrpcout.daemon.pl -m $mobilenumber -b 1>$TRN.txt 2>$TRN.warnings
date >>$TRN.txt
date >>$TRN.warnings 

TRN=test/report/o2xmlrpcin-report
test/test-o2xmlrpcin.daemon.pl 1>$TRN.txt 2>$TRN.warnings
date >>$TRN.txt
date >>$TRN.warnings 


date
TRN=../../test/report/libsmsengine-report
cd lib/Doolin
perl Makefile.PL
make test TEST_VERBOSE=1 1>$TRN.txt 2>$TRN.warnings
# note that error case tests cause warnings to stderr
date >>$TRN.txt
date >>$TRN.warnings 

