#!/usr/bin/perl

use strict;

my($verbose, @md5, @row, %now, %then, $ver, %files, $file);

if ($ARGV[0] eq '-v') {
    $verbose = 1;
}

@md5 = `md5sum \`cat MANIFEST\` 2> /dev/null`;
chomp(@md5);
%now = map { @row = split(/ +/, $_);
             $files{$row[1]} = 1;
	     $row[1] => $row[0] } @md5;

open(VER, "<VERSION");
$ver = <VER>;
chomp($ver);
@md5 = <VER>;
close(VER);
chomp(@md5);
%then = map { @row = split(/ +/, $_);
             $files{$row[1]} = 1;
	     $row[1] => $row[0] } @md5;

print("Verifying that the package is for version $ver.\n");
for $file (sort(keys(%files))) {
    if (!defined($now{$file})) {
	print("missing\t\t$file\n");
    } elsif ($now{$file} eq $then{$file}) {
	print("ok\t\t$file\n") if $verbose;
    } else {
	print("changed\t\t$file\n");
    }
}
